//////////////////////////////////////////////////////////////////////
//                              ExecModify                       
// Copyright 2014 Malcolm Stagg
// Modified Version 1.0: 06/05/2014
//
//////////////////////////////////////////////////////////////////////

/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this program.  If not, see
<http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#include "inc/IProcessorOpcode.h"
#include "inc/ArmOpcode.h"

// 1110    00  0              1101  0                   0000  1111       000000001110
// always      not immediate  mov   not mod conditions  op1   dest (PC)  op2 (LR)


const char cArmReturn[] = { 0xE1, 0xA0, 0xF0, 0x0E }; // MOV PC, LR

bool ArmOpcode::GetOpcode(char * szFromCode, char * szToOpcode, int &cbToOpcode)
{
	// just return code for now

	if (strcmp(szFromCode, "return;") == 0)
	{
		if (cbToOpcode >= sizeof(cArmReturn))
		{
			memcpy(szToOpcode, cArmReturn, sizeof(cArmReturn));
			cbToOpcode = sizeof(cArmReturn);
			return true;
		}
	}

	return false;
}
