//////////////////////////////////////////////////////////////////////
//                              ExecModify                       
// Copyright 2014 Malcolm Stagg
// Modified Version 1.0: 06/05/2014
//
//////////////////////////////////////////////////////////////////////

/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this program.  If not, see
<http://www.gnu.org/licenses/>.
*/

#ifndef __EXEC_PARSE_UTIL_H__
#define __EXEC_PARSE_UTIL_H__

#pragma once

enum Endianess 
{
	unknown_endian = 0,
	little_endian = 1,
	big_endian = 2
};

Endianess GetHostByteOrder();
void ConvertEndian64(uint64_t &number, Endianess from_endian, Endianess to_endian);
void ConvertEndian32(uint32_t &number, Endianess from_endian, Endianess to_endian);
void ConvertEndian16(uint16_t &number, Endianess from_endian, Endianess to_endian);
int64_t GetNumber(const char * szOptionVal);

// macros to allow better logging later

#define LOG_ERROR(x) \
	printf("\nError: " x "\n");

#define LOG_WARNING(x) \
	printf("\nWarning: " x "\n");

#define LOG_INFO(x) \
	printf("\nInfo: " x "\n");

#endif
